mod Ex08c

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  8. CVIČENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.20 
  \para* \it  Dátum:  \end streda 19.11.2014 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-450-lpi/1415zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované obecne 
  rekurzívnym funkciam. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 24.11.2014 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/3 Tex_f3_rec_af_f
  Prefix(90,2,Subsup(Id(0,'f',0),75,None,Id(1,'+',0)),
         Fenced(Op('(',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(')',0)))

appldisp/2 Tex_f2_d
  Std('d',0)

appldisp/2 Tex_f2_a
  Std('A',0)

rem 
  \para \bf  [CL] Remark.  \end Clausal form of function definitions is allowed. 

rem 
  \para \bf  Chapter. General Recursive Functions.  \end 

rem 
  \para \bf  Section. \ft Tex0_mu \end-recursive Functions.  \end 

rem 
  \para \bf  Definition of \ft Tex0_mu \end-recursive functions.  \end 

rem 
  \para \bf  Theorem.  \end The class of \ft Tex0_mu \end-recursive functions is 
  primitively recursively closed. 

rem 
  \para \bf  Corollary.  \end 
  \items 
   \item \para Every primitive recursive function is \ft Tex0_mu \end-recursive. 
   \item \para Every primitive recursive predicate is 
         \ft Tex0_mu \end-recursive. 
   \item \para \ft Tex0_mu \end-recursive functions are closed under explicit 
         definitions. 
   \item \para \ft Tex0_mu \end-recursive predicates are closed under explicit 
         definitions of predicates with bounded formulas. 
   \item \para \ft Tex0_mu \end-recursive functions are closed under nested 
         simple recursion. 
  \end

rem 
  \para \bf  Theorem.  \end \ft Tex0_mu \end-recursive functions are closed 
  under regular minimalization. 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Consider the following 
  definition of the Ackermann-Péter function by nested double recursion: 

fun/2 A 
  A(0,y) = y+1
  A(x+1,0) = A(x,1)
  A(x+1,y+1) = A(x,A(x+1,y))

rem 
  \para \header* fun/3 Af_a 'Tex_f3_rec_af_f' \end Derive the function 
  \ft A(x,y) \end as \ft Tex0_mu \end-recursive with the help of its 
  approximation function \ft Af_a(z,x,y) \end such that 
  \eq* 
    \a x\a y\e z Af_a(z,x+1,y+1) = A(x,y)+1
  \end
  \eq* 
    z1 <= z2 & Af_a(z1,x+1,y+1) = v+1 -> Af_a(z2,x+1,y+1) = v+1
  \end

fun/3 Af_a 'Tex_f3_rec_af_f'
  Af_a(z,x,y) = Foo

fun/2 Depth 'Tex_f2_d'
  Depth(x,y) = Foo

fun/2 A_is_murec 'Tex_f2_a'
  A_is_murec(x,y) = Foo

rem 
  \para \bf  Theorem.  \end The class of \ft Tex0_mu \end-recursive functions is 
  closed under regular recursion. 

rem 
  \para \bf  Theorem.  \end The class of general recursive functions coincides 
  with the class of \ft Tex0_mu \end-recursive functions. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

